Index: trunk/gli/src/org/greenstone/gatherer/Gatherer.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/Gatherer.java	(revision 10362)
+++ trunk/gli/src/org/greenstone/gatherer/Gatherer.java	(revision 10363)
@@ -149,35 +149,16 @@
 	    Configuration.GS3_CONFIG_XML = "config3Remote.xml";
 
-	    File col_dir = new File(Gatherer.getCollectDirectoryPath());
-	    if (!col_dir.exists()) {
-		if (JarTools.isInJar(Utility.COLLECT_ZIP)) {
-		    // Dig out collect.zip from JAR file and unzip it (thereby
-		    // creating collect directory and descendants.
-		    //   This is done to seed gsdl home folder with config files
-		    //   for documented example collections so "base this on
-		    //   existing collection" works
-		    ZipTools.unzipFromJar(Utility.COLLECT_ZIP, getGLIUserDirectoryPath());
-		}
-		else {
-		    // Prepare an empty collect dir for general use
-		    if (!col_dir.mkdir()) {
-			System.err.println("Warning: Unable to make directory: " + col_dir.toString());
-		    }
-		}
-	    }
-
-	    File metadata_directory = new File(Gatherer.getGLIMetadataDirectoryPath());
-	    if (!metadata_directory.exists()) {
-		// dig out metadata.zip from JAR file and unzip it
-		ZipTools.unzipFromJar(Utility.METADATA_ZIP, getGLIUserDirectoryPath());
-	    }
-
-	    File plug_dat = new File(getGLIUserDirectoryPath() + "plugins.dat");
-	    if (!plug_dat.exists()) {
+	    File collect_directory = new File(Gatherer.getCollectDirectoryPath());
+	    if (!collect_directory.exists() && !collect_directory.mkdir()) {
+		System.err.println("Warning: Unable to make directory: " + collect_directory);
+	    }
+
+	    File plugins_dat_file = new File(getGLIUserDirectoryPath() + "plugins.dat");
+	    if (!plugins_dat_file.exists()) {
 		JarTools.extractFromJar("plugins.dat", getGLIUserDirectoryPath(), false);
 	    }
 
-	    File class_dat = new File(getGLIUserDirectoryPath() + "classifiers.dat");
-	    if (!class_dat.exists()) {
+	    File classifiers_dat_file = new File(getGLIUserDirectoryPath() + "classifiers.dat");
+	    if (!classifiers_dat_file.exists()) {
 		JarTools.extractFromJar("classifiers.dat", getGLIUserDirectoryPath(), false);
 	    }
Index: trunk/gli/src/org/greenstone/gatherer/GathererApplet.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/GathererApplet.java	(revision 10362)
+++ trunk/gli/src/org/greenstone/gatherer/GathererApplet.java	(revision 10363)
@@ -36,5 +36,7 @@
 import java.io.*;
 import javax.swing.*;
+import org.greenstone.gatherer.util.JarTools;
 import org.greenstone.gatherer.util.Utility;
+import org.greenstone.gatherer.util.ZipTools;
 
 
@@ -129,4 +131,28 @@
 	                };
 
+	File collect_directory = new File(Gatherer.getCollectDirectoryPath());
+	if (!collect_directory.exists()) {
+	    if (JarTools.isInJar("collect.zip")) {
+		// Dig out collect.zip from JAR file and unzip it (thereby
+		// creating collect directory and descendants.
+		//   This is done to seed gsdl home folder with config files
+		//   for documented example collections so "base this on
+		//   existing collection" works
+		ZipTools.unzipFromJar("collect.zip", Gatherer.getGLIUserDirectoryPath());
+	    }
+	    else {
+		// Prepare an empty collect dir for use
+		if (!collect_directory.mkdir()) {
+		    System.err.println("Warning: Unable to make directory: " + collect_directory);
+		}
+	    }
+	}
+
+	File metadata_directory = new File(Gatherer.getGLIMetadataDirectoryPath());
+	if (!metadata_directory.exists()) {
+	    // dig out metadata.zip from JAR file and unzip it
+	    ZipTools.unzipFromJar("metadata.zip", Gatherer.getGLIDirectoryPath());
+	}
+
 	// Create an instance of the Gatherer class, which will parse the args and prepare the rest of the GLI
 	gatherer = new Gatherer(args);
Index: trunk/gli/src/org/greenstone/gatherer/util/Utility.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/util/Utility.java	(revision 10362)
+++ trunk/gli/src/org/greenstone/gatherer/util/Utility.java	(revision 10363)
@@ -87,7 +87,4 @@
     /** Definition of an important directory name, in this case the location of the expected collection metadata sets.. */
     static final public String META_DIR = "metadata" + File.separator; // Col. Copy
-    /** Definition of an important zip file, in this case zipped up version of metadata file stored in JAR file */
-    static final public String METADATA_ZIP = "metadata.zip";
-    static final public String COLLECT_ZIP = "collect.zip";
     /** The default name of the perl executable under unix. */
     static final public String PERL_EXECUTABLE_UNIX = "perl";