Index: trunk/gsdl/perllib/strings.rb
===================================================================
--- trunk/gsdl/perllib/strings.rb	(revision 10409)
+++ trunk/gsdl/perllib/strings.rb	(revision 10410)
@@ -424,12 +424,4 @@
 DateList.sort:An extra metadata field to sort by in the case where two documents have the same date.
 
-GenericList.alwaysgrouplastelement:Create a bookshelf icon even if there is only one item in each group at the leaf nodes.
-GenericList.classify_sections:Classify sections instead of documents.
-GenericList.desc:A general and flexible list classifier with most of the abilities of AZCompactList, but with better Unicode, metadata and sorting capabilities.
-GenericList.hlistgroupsize:The number of items in each hlist group (constantsize hlistgrouptype only).
-GenericList.hlistgrouptype:The type of hlist grouping done: either perletter, constantsize, or none.
-GenericList.leafnodesort:Metadata fields used for sorting the leaf nodes. Use ';' to separate the metadata groups to stable sort and ',' to separate metadata fields within each group.
-GenericList.metadata:Metadata fields used for classification. Use '/' to separate the levels in the hierarchy and ',' to separate metadata fields within each level.
-
 HFileHierarchy.desc:Classifier plugin for generating hierarchical classifications based on a supplementary structure file.
 
@@ -600,9 +592,15 @@
 BookPlug.desc:Creates multi-level document from document containing <<TOC>> level tags. Metadata for each section is taken from any other tags on the same line as the <<TOC>>. e.g. <<Title>>xxxx<</Title>> sets Title metadata. Everything else between TOC tags is treated as simple html (i.e. no processing of html links or any other HTMLPlug type stuff is done). Expects input files to have a .hb file extension by default (this can be changed by adding a -process_exp option a file with the same name as the hb file but a .jpg extension is taken as the cover image (jpg files are blocked by this plugin). BookPlug is a simplification (and extension) of the HBPlug used by the Humanity Library collections. BookPlug is faster as it expects the input files to be cleaner (The input to the HDL collections contains lots of excess html tags around <<TOC>> tags, uses <<I>> tags to specify images, and simply takes all text between <<TOC>> tags and start of text to be Title metadata). If you're marking up documents to be displayed in the same way as the HDL collections, use this plugin instead of HBPlug.
 
-ConvertToPlug.convert_to:Plugin converts to TEXT or HTML.
+BRSPlug.desc: BRSPlug deals with the BBC collections. There are three BBC collections we deliver, which are National Sound Archive (nsa), British Film Institute (bfi), and BBC Other (bbcother) (everything does not fit into one of the first two). Four options are provided which are all-build all collections, nsa-build the NSA collections, bfi-build the BFI collections, bbcother-build the OTHER collections.
+
+ConvertToPlug.convert_to:Plugin converts to TEXT or HTML or various types of Image (e.g. JPEG, GIF, PNG).
+ConvertToPlug.convert_to.auto:Automatically select the format converted too.  Format chosen depends on input document type, for example Word will automatically be converted to HTML, whereas PowerPoint will be converted to Greenstone's PagedImage format.
 ConvertToPlug.convert_to.html:HTML format.
 ConvertToPlug.convert_to.text:Plain text format.
-
-ConvertToPlug.desc:The plugin is inherited by such plugins as WordPlug and PDFPlug. It facilitates the conversion of these document types to either HTML or TEXT by setting up variable that instruct ConvertToBasPlug how to work. It works by dynamically inheriting HTMLPlug or TEXTPlug based on the plugin argument 'convert_to'.  If the argument is not present, the default is to inherit HTMLPlug.
+ConvertToPlug.convert_to.pagedimg_jpg:JPEG format.
+ConvertToPlug.convert_to.pagedimg_gif:GIF format.
+ConvertToPlug.convert_to.pagedimg_png:PNG format. 
+
+ConvertToPlug.desc:The plugin is inherited by such plugins as WordPlug and PDFPlug. It facilitates the conversion of these document types to either HTML or TEXT by setting up variable that instruct ConvertToBasPlug how to work. It works by dynamically inheriting HTMLPlug or TEXTPlug based on the plugin argument 'convert_to'. If the argument is not present, the default is to inherit HTMLPlug.
 
 ConvertToPlug.use_strings:If set, a simple strings function will be called to extract text if the conversion utility fails.
@@ -614,8 +612,8 @@
 DBPlug.title_sub:Substitution expression to modify string stored as Title. Used by, for example, PSPlug to remove "Page 1" etc from text used as the title.
 
-DSpacePlug.desc:
-DSpacePlug.first_inorder_ext:
-DSpacePlug.first_inorder_mime:
-DSpacePlug.only_first_doc:
+DSpacePlug.desc:DSpacePlug reads the DSpace Export collection and its dublin_core metadata file, and convert to GSII compilance format.	
+DSpacePlug.first_inorder_ext: This is used to identify the primary stream of DSpace collection document. With this option, the system will treat the defined ext types of document in sequence to look for the possible primary stream. 
+DSpacePlug.first_inorder_mime:This is used to identify the primary data stream of DSpace collection document.With this option, the system will treat the defined mime types of document in sequence to look for the possible primary stream. 
+DSpacePlug.only_first_doc:This is used to identify the primary data stream of DSpace collection document.With this option, the system will treat the first document in dublic_core metadata file as the possible primary stream. 
 
 EMAILPlug.desc:Email plug reads email files.  These are named with a simple number (i.e. as they appear in maildir folders) or with the extension .mbx (for mbox mail file format).\nDocument text: The document text consists of all the text after the first blank line in the document.\nMetadata (not Dublin Core!):\n\t\$Headers      All the header content (optional, not stored by default)\n\t\$Subject      Subject: header\n\t\$To           To: header\n\t\$From         From: header\n\t\$FromName     Name of sender (where available)\n\t\$FromAddr     E-mail address of sender\n\t\$DateText     Date: header\n\t\$Date         Date: header in GSDL format (eg: 19990924)
@@ -741,4 +739,6 @@
 
 PPTPlug.desc:A plugin for importing Microsoft PowerPoint files.
+
+PPTPlug.windows_scripting:Use MicroSoft Windows scripting technology (Visual Basic for Applications) to get PPT to convert document to various image types (e.g. JPEG,PNG,GIF) rather than rely on the open source package ppttohtml. 
 
 PSPlug.desc:This is a \"poor man's\" ps to text converter. If you are serious, consider using the PRESCRIPT package, which is available for download at http://www.nzdl.org/html/software.html
@@ -839,8 +839,24 @@
 WordPlug.desc:A plugin for importing Microsoft Word documents.
 
+WordPlug.windows_scripting:Use MicroSoft Windows scripting technology (Visual Basic for Applications) to get Word to convert document to HTML rather than rely on the open source package WvWare.  Causes Word application to open on screen if not already running.
+
+
+WordPlug.checkout_toc:If the option flag is set, it means that we want to get rid of the "Table of Content" and "List of Table" within the word document. 
+
+WordPlug.title_header:set up the possible user-defined style for the title_header.
+
+WordPlug.level1_header:possible user-defined styles for the level1 header in the HTML document (equivalent to <h1>).
+
+WordPlug.level2_header:possible user-defined styles for the level2 header in the HTML document (equivalent to <h2>).
+
+WordPlug.level3_header:possible user-defined styles for the level3 header in the HTML document (equivalent <h3>).
+
+WordPlug.toc_header:possible user-defined header styles for the TOC.
+
+WordPlug.tof_header:possible user-defined header styles for the TOF
+
 XMLPlug.desc:Base class for XML plugins.
 
 XMLPlug.xslt:Transform a matching input document with the XSLT in the named file.  A relative filename is assumed to be in the collection's file area, for instance etc/mods2dc.xsl.
-
 ZIPPlug.desc:Plugin which handles compressed and/or archived input formats currently handled formats and file extensions are:\ngzip (.gz, .z, .tgz, .taz)\nbzip (.bz)\nbzip2 (.bz2)\nzip (.zip .jar)\ntar (.tar)\n\nThis plugin relies on the following utilities being present (if trying to process the corresponding formats):\ngunzip (for gzip)\nbunzip (for bzip)\nbunzip2 \nunzip (for zip)\ntar (for tar)
 