Index: trunk/gli/src/org/greenstone/gatherer/cdm/CollectionConfiguration.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/cdm/CollectionConfiguration.java	(revision 10512)
+++ trunk/gli/src/org/greenstone/gatherer/cdm/CollectionConfiguration.java	(revision 10515)
@@ -212,59 +212,59 @@
 	String command_element_name = command_element.getNodeName();
 	if(command_element_name.equals(CLASSIFY_ELEMENT)) {
-	    return self.classifyToString(command_element, show_extracted_namespace);
+	    return classifyToString(command_element, show_extracted_namespace);
 	}
 	else if(command_element_name.equals(FORMAT_ELEMENT)) {
-	    return self.formatToString(command_element, show_extracted_namespace);
+	    return formatToString(command_element, show_extracted_namespace);
 	}
 	else if(command_element_name.equals(INDEXES_ELEMENT)) {
-	    return self.indexesToString(command_element, show_extracted_namespace);
+	    return indexesToString(command_element, show_extracted_namespace);
 	}
 	else if(command_element_name.equals(INDEX_DEFAULT_ELEMENT)) {
-	    return self.indexDefaultToString(command_element, show_extracted_namespace);
+	    return indexDefaultToString(command_element, show_extracted_namespace);
 	}
 	else if(command_element_name.equals(LANGUAGES_ELEMENT)) {
-	    return self.languagesToString(command_element);
+	    return languagesToString(command_element);
 	}
 	else if(command_element_name.equals(LANGUAGE_DEFAULT_ELEMENT)) {
-	    return self.languageDefaultToString(command_element);
+	    return languageDefaultToString(command_element);
 	}
 	else if(command_element_name.equals(LEVELS_ELEMENT)) {
-	    return self.levelsToString(command_element);
+	    return levelsToString(command_element);
 	}
 	else if(command_element_name.equals(COLLECTIONMETADATA_ELEMENT)) {
-	    return self.metadataToString(command_element, show_extracted_namespace);
+	    return metadataToString(command_element, show_extracted_namespace);
 	}
 	else if(command_element_name.equals(COLLECTIONMETADATA_CREATOR_ELEMENT)) {
-	    return self.metadataToString(command_element, show_extracted_namespace);
+	    return metadataToString(command_element, show_extracted_namespace);
 	}
 	else if(command_element_name.equals(COLLECTIONMETADATA_MAINTAINER_ELEMENT)) {
-	    return self.metadataToString(command_element, show_extracted_namespace);
+	    return metadataToString(command_element, show_extracted_namespace);
 	}
 	else if(command_element_name.equals(COLLECTIONMETADATA_PUBLIC_ELEMENT)) {
-	    return self.metadataToString(command_element, show_extracted_namespace);
+	    return metadataToString(command_element, show_extracted_namespace);
 	}
 	else if (command_element_name.equals(BUILDTYPE_ELEMENT)) {
-	    return self.metadataToString(command_element, show_extracted_namespace);
+	    return metadataToString(command_element, show_extracted_namespace);
 	}
 	else if(command_element_name.equals(PLUGIN_ELEMENT)) {
-	    return self.pluginToString(command_element, show_extracted_namespace);
+	    return pluginToString(command_element, show_extracted_namespace);
 	}
 	else if(command_element_name.equals(SEARCHTYPE_ELEMENT)) {
-	    return self.searchtypeToString(command_element);
+	    return searchtypeToString(command_element);
 	}
 	else if(command_element_name.equals(SUBCOLLECTION_ELEMENT)) {
-	    return self.subcollectionToString(command_element, show_extracted_namespace);
+	    return subcollectionToString(command_element, show_extracted_namespace);
 	}
 	else if(command_element_name.equals(SUBCOLLECTION_DEFAULT_INDEX_ELEMENT)) {
-	    return self.subcollectionDefaultIndexToString(command_element);
+	    return subcollectionDefaultIndexToString(command_element);
 	}
 	else if(command_element_name.equals(SUBCOLLECTION_INDEXES_ELEMENT)) {
-	    return self.subcollectionIndexesToString(command_element);
+	    return subcollectionIndexesToString(command_element);
 	}
 	else if(command_element_name.equals(SUPERCOLLECTION_ELEMENT)) {
-	    return self.supercollectionToString(command_element);
+	    return supercollectionToString(command_element);
 	}
 	else if(command_element_name.equals(UNKNOWN_ELEMENT)) {
-	    return self.unknownToString(command_element);
+	    return unknownToString(command_element);
 	}
 	return "";
@@ -309,6 +309,4 @@
     static private ArrayList known_metadata;
 
-    static private CollectionConfiguration self;
-
     /** Gives the preferred ordering of commands */
     static final private String[] COMMAND_ORDER = {StaticStrings.COLLECTIONMETADATA_CREATOR_ELEMENT, StaticStrings.COLLECTIONMETADATA_MAINTAINER_ELEMENT, StaticStrings.COLLECTIONMETADATA_PUBLIC_ELEMENT,  StaticStrings.SEARCHTYPE_ELEMENT, StaticStrings.BUILDTYPE_ELEMENT, StaticStrings.PLUGIN_ELEMENT, StaticStrings.INDEXES_ELEMENT, StaticStrings.LEVELS_ELEMENT, StaticStrings.INDEX_DEFAULT_ELEMENT, StaticStrings.LANGUAGES_ELEMENT, StaticStrings.LANGUAGE_DEFAULT_ELEMENT, StaticStrings.SUBCOLLECTION_ELEMENT, StaticStrings.SUBCOLLECTION_INDEXES_ELEMENT, StaticStrings.SUBCOLLECTION_DEFAULT_INDEX_ELEMENT, StaticStrings.SUPERCOLLECTION_ELEMENT, StaticStrings.CLASSIFY_ELEMENT, StaticStrings.FORMAT_ELEMENT, StaticStrings.COLLECTIONMETADATA_ELEMENT};
@@ -322,6 +320,6 @@
     /** ************************** Public Methods ***************************/
 
-    public CollectionConfiguration(File collect_cfg_file) {
-	this.self = this;
+    public CollectionConfiguration(File collect_cfg_file)
+    {
 	this.collect_cfg_file = collect_cfg_file;
 	// If collect_cfg is xml we can load it straight away
@@ -531,5 +529,5 @@
     /** ************************** Private Methods ***************************/
 
-    private String classifyToString(Element command_element, boolean show_extracted_namespace)
+    static private String classifyToString(Element command_element, boolean show_extracted_namespace)
     {
 	StringBuffer text = new StringBuffer(CLASSIFY_STR);
@@ -589,5 +587,5 @@
     }
 
-    private String formatToString(Element command_element, boolean show_extracted_namespace) {
+    static private String formatToString(Element command_element, boolean show_extracted_namespace) {
 	StringBuffer text = new StringBuffer(FORMAT_STR);
 	text.append(SPACE_CHARACTER);
@@ -616,5 +614,5 @@
 
     /** Retrieve or create the indexes Element. */
-    private Element getOrCreateElementByTagName(String name, String conditional_attribute, String required_value) {
+    static private Element getOrCreateElementByTagName(String name, String conditional_attribute, String required_value) {
 	Element document_element = document.getDocumentElement();
 	NodeList elements = document_element.getElementsByTagName(name);
@@ -653,5 +651,5 @@
     }
 
-    private String indexesToString(Element command_element, boolean show_extracted_namespace) {
+    static private String indexesToString(Element command_element, boolean show_extracted_namespace) {
 	boolean comment_only = false;
 	StringBuffer text = new StringBuffer("");
@@ -707,5 +705,5 @@
     }
 
-    private String indexDefaultToString(Element command_element, boolean show_extracted_namespace) {
+    static private String indexDefaultToString(Element command_element, boolean show_extracted_namespace) {
 	StringBuffer text = new StringBuffer("");
 	if(command_element.getAttribute(ASSIGNED_ATTRIBUTE).equals(FALSE_STR)) {
@@ -735,5 +733,5 @@
     }
 
-    private String languagesToString(Element command_element) {
+    static private String languagesToString(Element command_element) {
 	StringBuffer text = new StringBuffer(LANGUAGES_STR);
 	text.append(TAB_CHARACTER);
@@ -754,5 +752,5 @@
     }
 
-    private String languageDefaultToString(Element command_element) {
+    static private String languageDefaultToString(Element command_element) {
 	StringBuffer text = new StringBuffer(LANGUAGE_DEFAULT_STR);
 	text.append(TAB_CHARACTER);
@@ -761,5 +759,5 @@
     }
 
-    private String levelsToString(Element command_element) {
+    static private String levelsToString(Element command_element) {
 	StringBuffer text = new StringBuffer("");
 	if(!command_element.getAttribute(ASSIGNED_ATTRIBUTE).equals(TRUE_STR)) {
@@ -783,5 +781,5 @@
     }
 
-    static public String metadataToString(Element command_element, boolean text_value) {
+    static private String metadataToString(Element command_element, boolean text_value) {
 	boolean special = false;
 	// If there is no value attribute, then we don't write anything
@@ -1530,5 +1528,5 @@
     }
 
-    private String pluginToString(Element command_element, boolean show_extracted_namespace) {
+    static private String pluginToString(Element command_element, boolean show_extracted_namespace) {
 	StringBuffer text = new StringBuffer();
 	if(!command_element.getAttribute(SEPARATOR_ATTRIBUTE).equals(TRUE_STR)) {
@@ -1575,5 +1573,5 @@
     }
 
-    private String searchtypeToString(Element command_element) {
+    static private String searchtypeToString(Element command_element) {
 	if(command_element.getAttribute(ASSIGNED_ATTRIBUTE).equals(TRUE_STR)) {
 	    StringBuffer text = new StringBuffer(SEARCHTYPE_STR);
@@ -1593,5 +1591,5 @@
     }
 
-    private String subcollectionToString(Element command_element, boolean show_extracted_namespace) {
+    static private String subcollectionToString(Element command_element, boolean show_extracted_namespace) {
 	StringBuffer text = new StringBuffer(SUBCOLLECTION_STR);
 	text.append(SPACE_CHARACTER);
@@ -1621,5 +1619,5 @@
     }
 
-    private String subcollectionDefaultIndexToString(Element command_element) {
+    static private String subcollectionDefaultIndexToString(Element command_element) {
 	StringBuffer text = new StringBuffer(SUBCOLLECTION_DEFAULT_INDEX_STR);
 	text.append(TAB_CHARACTER);
@@ -1636,5 +1634,5 @@
     }
 
-    private String subcollectionIndexesToString(Element command_element) {
+    static private String subcollectionIndexesToString(Element command_element) {
 	StringBuffer text = new StringBuffer(SUBCOLLECTION_INDEX_STR);
 	text.append(TAB_CHARACTER);
@@ -1663,5 +1661,5 @@
     }
 
-    private String supercollectionToString(Element command_element) {
+    static private String supercollectionToString(Element command_element) {
 	NodeList content_elements = command_element.getElementsByTagName(COLLECTION_ELEMENT);
 	int content_elements_length = content_elements.getLength();
@@ -1681,5 +1679,5 @@
     }
 
-    private String unknownToString(Element command_element) {
+    static private String unknownToString(Element command_element) {
 	return XMLTools.getValue(command_element);
     }