Index: /trunk/gsdl/macros/base.dm
===================================================================
--- /trunk/gsdl/macros/base.dm	(revision 10596)
+++ /trunk/gsdl/macros/base.dm	(revision 10597)
@@ -34,18 +34,4 @@
 _collectionname_ {}
 
-package Usability
-
-_content_ {
-<h2>_textaboutusabilitytitle_</h2>
-<p>_textaboutusability_
-}
-_pagetitle_{_textaboutusabilitypagetitle_}
-
-package Privacy
-_content_ {
-<h2>_textaboutprivacytitle_</h2>
-<p>_textaboutprivacy_
-}
-_pagetitle_{_textaboutprivacypagetitle_}
 
 package Global
@@ -462,10 +448,10 @@
 #######################################################################
 
-_iconnext_{<img src="_httpiconmore_" align=absbottom 
-width=_widthmore_ height=_heightmore_ border="0" alt="_texticonnext_" title="_texticonnext_">}
+_iconnext_{<img src="_httpiconmore_" align="absbottom"
+width="_widthmore_" height="_heightmore_" border="0" alt="_texticonnext_" title="_texticonnext_">}
 _iconnext_[v=1] {_texticonnext_}
 
-_iconprev_{<img src="_httpiconless_" align=absbottom 
-width=_widthless_ height=_heightless_ border="0" alt="_texticonprev_" title="_texticonprev_">}
+_iconprev_{<img src="_httpiconless_" align="absbottom"
+width="_widthless_" height="_heightless_" border="0" alt="_texticonprev_" title="_texticonprev_">}
 _iconprev_[v=1] {_texticonprev_}
 
@@ -480,44 +466,44 @@
 _icontabTitlegreen_[v=1] {_texticontabTitlegreen_}
 
-_icontabCreatorgreen_ {<img src="_httpicontcreatgr_" width="_widthtcreatx_" border=0>}
+_icontabCreatorgreen_ {<img src="_httpicontcreatgr_" width="_widthtcreatx_" border="0">}
 _icontabCreatorgreen_[v=1] {_texticontabCreatorgreen_}
 
-_icontabSubjectgreen_ {<img src="_httpicontsubjgr_" width=_widthtsubjx_ border=0>}
+_icontabSubjectgreen_ {<img src="_httpicontsubjgr_" width="_widthtsubjx_" border="0">}
 _icontabSubjectgreen_[v=1] {_texticontabSubjectgreen_}
 
-_icontabDescriptiongreen_ {<img src="_httpicontdescgr_" width=_widthtdescx_ border=0>}
+_icontabDescriptiongreen_ {<img src="_httpicontdescgr_" width="_widthtdescx_" border="0">}
 _icontabDescriptiongreen_[v=1] {_texticontabDescriptiongreen_}
 
-_icontabPublishergreen_ {<img src="_httpicontpublgr_" width=_widthtpublx_ border=0>}
+_icontabPublishergreen_ {<img src="_httpicontpublgr_" width="_widthtpublx_" border="0">}
 _icontabPublishergreen_[v=1] {_texticontabPublishergreen_}
 
-_icontabContributorgreen_ {<img src="_httpicontcontrgr_" width=_widthtcontrx_ border=0>}
+_icontabContributorgreen_ {<img src="_httpicontcontrgr_" width="_widthtcontrx_" border="0">}
 _icontabContributorgreen_[v=1] {_texticontabContributorgreen_}
 
-_icontabDategreen_ {<img src="_httpicontdategr_" width=_widthtdatex_ border=0>}
+_icontabDategreen_ {<img src="_httpicontdategr_" width="_widthtdatex_" border="0">}
 _icontabDategreen_[v=1] {_texticontabDategreen_}
 
-_icontabTypegreen_ {<img src="_httpiconttypegr_" width=_widthttypex_ border=0>}
+_icontabTypegreen_ {<img src="_httpiconttypegr_" width="_widthttypex_" border="0">}
 _icontabTypegreen_[v=1] {_texticontabTypegreen_}
 
-_icontabFormatgreen_ {<img src="_httpicontformgr_" width=_widthtformx_ border=0>}
+_icontabFormatgreen_ {<img src="_httpicontformgr_" width="_widthtformx_" border="0">}
 _icontabFormatgreen_[v=1] {_texticontabFormatgreen_}
 
-_icontabIdentifiergreen_ {<img src="_httpicontidentgr_" width=_widthtidentx_ border=0>}
+_icontabIdentifiergreen_ {<img src="_httpicontidentgr_" width="_widthtidentx_" border="0">}
 _icontabIdentifiergreen_[v=1] {_texticontabIdentifiergreen_}
 
-_icontabSourcegreen_ {<img src="_httpicontsrcgr_" width=_widthtsrcx_ border=0>}
+_icontabSourcegreen_ {<img src="_httpicontsrcgr_" width="_widthtsrcx_" border="0">}
 _icontabSourcegreen_[v=1] {_texticontabSourcegreen_}
 
-_icontabLanguagegreen_ {<img src="_httpicontlanggr_" width=_widthtlangx_ border=0>}
+_icontabLanguagegreen_ {<img src="_httpicontlanggr_" width="_widthtlangx_" border="0">}
 _icontabLanguagegreen_[v=1] {_texticontabLanguagegreen_}
 
-_icontabRelationgreen_ {<img src="_httpicontrelgr_" width=_widthtrelx_ border=0>}
+_icontabRelationgreen_ {<img src="_httpicontrelgr_" width="_widthtrelx_" border="0">}
 _icontabRelationgreen_[v=1] {_texticontabRelationgreen_}
 
-_icontabCoveragegreen_ {<img src="_httpicontcovergr_" width=_widthtcoverx_ border=0>}
+_icontabCoveragegreen_ {<img src="_httpicontcovergr_" width="_widthtcoverx_" border="0">}
 _icontabCoveragegreen_[v=1] {_texticontabCoveragegreen_}
 
-_icontabRightsgreen_ {<img src="_httpicontrightgr_" width=_widthtrightx_ border=0>}
+_icontabRightsgreen_ {<img src="_httpicontrightgr_" width="_widthtrightx_" border="0">}
 _icontabRightsgreen_[v=1] {_texticontabRightsgreen_}
 
@@ -525,113 +511,113 @@
 
 _icontabListgreen_ {<img
-src="_httpicontlistgr_" width=_widthtlistx_ border=0>}
+src="_httpicontlistgr_" width="_widthtlistx_" border="0">}
 _icontablistgreen_ [v=1] {_texticontablistgreen_}
 
 _icontabCollagegreen_ {<img 
-src="_httpicontcollgr_" width=_widthtcollx_ border=0>}
+src="_httpicontcollgr_" width="_widthtcollx_" border="0">}
 _icontabCollagegreen_[v=1] {_texticontabCollagegreen_}
 
 _icontabSeriesgreen_ {<img 
-src="_httpicontsergr_" width=_widthtserx_ border=0>}
+src="_httpicontsergr_" width="_widthtserx_" border="0">}
 _icontabSeriesgreen_[v=1] {_texticontabseriesgreen_}
 
 _icontabTogreen_ {<img 
-src="_httpiconttogr_" width=_widthttox_ border=0>}
+src="_httpiconttogr_" width="_widthttox_" border="0">}
 _icontabTogreen_[v=1] {_texticontabtogreen_}
 
 _icontabFromgreen_ {<img 
-src="_httpicontfromgr_" width=_widthtfromx_ border=0>}
+src="_httpicontfromgr_" width="_widthtfromx_" border="0">}
 _icontabFromgreen_[v=1] {_texticontabfromgreen_}
 
 _icontabHowtogreen_ {<img 
-src="_httpiconthowgr_" width=_widththowx_ border=0>}
+src="_httpiconthowgr_" width="_widththowx_" border="0">}
 _icontabHowtogreen_[v=1] {_texticontabhowgreen_}
 
 _icontabTopicgreen_ {<img 
-src="_httpiconttopicgr_" width=_widthttopicx_ border=0>}
+src="_httpiconttopicgr_" width="_widthttopicx_" border="0">}
 _icontabTopicgreen_[v=1] {_texticontabtopicgreen_}
 
 _icontabBrowsegreen_ {<img 
-src="_httpicontbrwsegr_" width=_widthtbrwsex_ border=0>}
+src="_httpicontbrwsegr_" width="_widthtbrwsex_" border="0">}
 _icontabBrowsegreen_[v=1] {_texticontabbrwsegreen_}
 
 _icontabOrganizationgreen_ {<img 
-src="_httpicontorggr_" width=_widthtorgx_ border=0>}
+src="_httpicontorggr_" width="_widthtorgx_" border="0">}
 _icontabOrganizationgreen_[v=1] {_texticontaborggreen_}
 
 _icontabPeoplegreen_ {<img
-src="_httpicontpeopgr_" width=_widthtpeopx_ border=0>}
+src="_httpicontpeopgr_" width="_widthtpeopx_" border="0">}
 _icontabPeoplegreen_[v=1] {_texticontabPeoplegreen_}
 
 _icontabAcronymgreen_ {<img
-src="_httpicontacrogr_" width=_widthtacrox_ border=0>}
+src="_httpicontacrogr_" width="_widthtacrox_" border="0">}
 _icontabAcronymgreen_[v=1] {_texticontabAcronymgreen_}
 
 _icontabPhrasegreen_ {<img
-src="_httpicontphrsegr_" width=_widthtphrsex_ border=0>}
+src="_httpicontphrsegr_" width="_widthtphrsex_" border="0">}
 _icontabPhrasegreen_[v=1] {_texticontabPhrasegreen_}
 
 _icontabArtistgreen_ {<img
-src="_httpicontartstgr_" width=_widthtartstx_ border=0>}
+src="_httpicontartstgr_" width="_widthtartstx_" border="0">}
 _icontabArtistgreen_[v=1] {_texticontabArtistgreen_}
 
 _icontabKeywordgreen_ {<img 
-src="_httpicontkwgr_" width=_widthtkwx_ border=0>}
+src="_httpicontkwgr_" width="_widthtkwx_" border="0">}
 _icontabKeywordgreen_[v=1] {_texticontabKeywordgreen_}
 
 _icontabVolumegreen_ {<img 
-src="_httpicontvolgr_" width=_widthtvolx_ border=0>}
+src="_httpicontvolgr_" width="_widthtvolx_" border="0">}
 _icontabVolumegreen_[v=1] {_texticontabVolumegreen_}
 
 _icontabCaptionsgreen_ {<img
-src="_httpicontcaptgr_" width=_widthtcaptx_ border=0>}
+src="_httpicontcaptgr_" width="_widthtcaptx_" border="0">}
 _icontabCaptionsgreen_[v=1] {_texticontabCaptionsgreen_}
 
 _icontabCountriesgreen_ {<img 
-src="_httpicontcountgr_" width=_widthtcountx_ border=0>}
+src="_httpicontcountgr_" width="_widthtcountx_" border="0">}
 _icontabCountriesgreen_[v=1] {_texticontabCountriesgreen_}
 
 
-_iconblankbar_ {<center><img src="_httpicondivb_" width=_widthdivb_ height=_heightdivb_></center>}
+_iconblankbar_ {<center><img src="_httpicondivb_" width="_widthdivb_" height="_heightdivb_"></center>}
 _iconblankbar_[v=1] {<br><hr><br>}
 
-_icontext_ {<img border=0 align=absmiddle src="_httpiconitext_" width=_widthitext_ height=_heightitext_ alt="_texticontext_" title="_texticontext_">}
+_icontext_ {<img border=0 align=absmiddle src="_httpiconitext_" width="_widthitext_" height="_heightitext_" alt="_texticontext_" title="_texticontext_">}
 _icontext_[v=1] {_texticontext_}
 
-_iconworld_ {<img border=0 align=absmiddle src="_httpiconiworld_" width=_widthiworld_ height=_heightiworld_ alt="_texticonworld_" title="_texticonworld_">}
+_iconworld_ {<img border=0 align=absmiddle src="_httpiconiworld_" width="_widthiworld_" height="_heightiworld_" alt="_texticonworld_" title="_texticonworld_">}
 _iconworld_[v=1] {_texticonworld_}
 
-_iconunknown_ {<img border=0 align=absmiddle src="_httpiconiunknown_" width=_widthiunknown_ height=_heightiunknown_ alt="_texticonunknown_" title="_texticonunknown_">}
+_iconunknown_ {<img border="0" align="absmiddle" src="_httpiconiunknown_" width="_widthiunknown_" height="_heightiunknown_" alt="_texticonunknown_" title="_texticonunknown_">}
 _iconunknown_[v=1] {_texticonunknown_}
 
-_iconblanktext_ {<img border=0 align=absmiddle src="_httpiconibtext_" width=_widthibtext_ height=_heightibtext_>}
+_iconblanktext_ {<img border="0" align="absmiddle" src="_httpiconibtext_" width="_widthibtext_" height="_heightibtext_">}
 _iconblanktext_[v=1] {}
 
-_iconclosedbook_ {<img src="_httpiconbook_" width=_widthbook_ height=_heightbook_ border=0 alt="_texticonclosedbook_" title="_texticonclosedbook_">}
+_iconclosedbook_ {<img src="_httpiconbook_" width="_widthbook_" height="_heightbook_" border="0" alt="_texticonclosedbook_" title="_texticonclosedbook_">}
 _iconclosedbook_ [v=1] {<small><b>_texticonclosedbook_: </b></small>}
 _iconclosedbook_ [v=1,l=zh]{<small><_font_><b>_texticonclosedbook_: </b></font></small>}
 
-_icondoc_ {<img border=0 align=absmiddle src="_httpiconimsword_" width=_widthimsword_ height=_heightimsword_ alt="_texticonmsword_" title="_texticonmsword_">}
+_icondoc_ {<img border="0" align="absmiddle" src="_httpiconimsword_" width="_widthimsword_" height="_heightimsword_" alt="_texticonmsword_" title="_texticonmsword_">}
 _icondoc_[v=1] {_texticonmsword_}
 
-_iconmp3_ {<img border=0 align=absmiddle src="_httpiconimp3_" width=_widthimp3_ height=_heightimp3_ alt="_texticonmp3_" title="_texticonmp3_">}
+_iconmp3_ {<img border="0" align="absmiddle" src="_httpiconimp3_" width="_widthimp3_" height="_heightimp3_" alt="_texticonmp3_" title="_texticonmp3_">}
 _iconmp3_[v=1] {_texticonmp3_}
 
-_iconmidi_ {<img border=0 align=absmiddle src="_httpiconimidi_" width=_widthimidi_ height=_heightimidi_ alt="_texticonmidi_" title="_texticonmidi_">}
+_iconmidi_ {<img border="0" align="absmiddle" src="_httpiconimidi_" width="_widthimidi_" height="_heightimidi_" alt="_texticonmidi_" title="_texticonmidi_">}
 _iconmidi_[v=1] {_texticonmidi_}
 
-_iconpdf_ {<img border=0 align=absmiddle src="_httpiconipdf_" width=_widthipdf_ height=_heightipdf_ alt="_texticonpdf_" title="_texticonpdf_">}
+_iconpdf_ {<img border="0" align="absmiddle" src="_httpiconipdf_" width="_widthipdf_" height="_heightipdf_" alt="_texticonpdf_" title="_texticonpdf_">}
 _iconpdf_[v=1] {_texticonpdf_}
 
-_iconps_ {<img border=0 align=absmiddle src="_httpiconips_" width=_widthips_ height=_heightips_ alt="_texticonps_" title="_texticonps_">}
+_iconps_ {<img border="0" align="absmiddle" src="_httpiconips_" width="_widthips_" height="_heightips_" alt="_texticonps_" title="_texticonps_">}
 _iconps_[v=1] {_texticonps_}
 
-_iconppt_ {<img border=0 align=absmiddle src="_httpiconippt_" width=_widthippt_ height=_heightippt_ alt="_texticonppt_" title="_texticonppt_">}
+_iconppt_ {<img border="0" align="absmiddle" src="_httpiconippt_" width="_widthippt_" height="_heightippt_" alt="_texticonppt_" title="_texticonppt_">}
 _iconppt_[v=1] {_texticonppt_}
 
-_iconrtf_ {<img border=0 align=absmiddle src="_httpiconirtf_" width=_widthirtf_ height=_heightirtf_ alt="_texticonrtf_" title="_texticonrtf_">}
+_iconrtf_ {<img border="0" align="absmiddle" src="_httpiconirtf_" width="_widthirtf_" height="_heightirtf_" alt="_texticonrtf_" title="_texticonrtf_">}
 _iconrtf_[v=1] {_texticonrtf_}
 
-_iconxls_ {<img border=0 align=absmiddle src="_httpiconixls_" width=_widthixls_ height=_heightixls_ alt="_texticonxls_" title="_texticonxls_">}
+_iconxls_ {<img border="0" align="absmiddle" src="_httpiconixls_" width="_widthixls_" height="_heightixls_" alt="_texticonxls_" title="_texticonxls_">}
 _iconxls_[v=1] {_texticonxls_}
 
@@ -652,6 +638,4 @@
 _imagepref2_ {_gsimage_(_httppagepref_,_httpiconcprefof_,_httpiconcprefon_,pref,_textimagepref_)}
 
-_imageusab_ {_gsimage_(_httppageusab_,_httpiconcusabof_,_httpiconcusabon_,usab,_textimageusab_)}
-
 _imagegreenstone_ {<img src="_httpicongsdl_" width="_widthgsdl_" height="_heightgsdl_" border="0" alt="_textimagegreenstone_" title="_textimagegreenstone_" hspace=0>}
 